<ui:composition xmlns:g="http://www.ihe.net/gazelle" xmlns:rich="http://richfaces.org/rich" xmlns:a4j="http://richfaces.org/a4j" xmlns:f="http://java.sun.com/jsf/core" xmlns:c="http://java.sun.com/jstl/core" xmlns:gdk="http://www.ihe.net/gazellecdk" xmlns:ui="http://java.sun.com/jsf/facelets" xmlns:gazelle="http://java.sun.com/jsf/composite/gazelle-tags" xmlns:h="http://java.sun.com/jsf/html" xmlns="http://www.w3.org/1999/xhtml">
  <c:forEach items="#{menu.items}" var="item">
    <rich:dropDownMenu rendered="#{item.visible}">
      <f:facet name="label">
        <h:panelGrid cellpadding="1" cellspacing="1" columns="2" style="vertical-align:middle" styleClass="#{not empty item.page.link ? 'menuEntry' : ''}">
          <h:graphicImage library="img" value="#{item.page.icon}" width="32" height="32"/>
          <h:outputText value="#{messages[item.page.label]}" style="white-space: nowrap;"/>
          <h:link rendered="#{not empty item.page.link}" view="#{item.page.link}">
            <h:outputText value=" "/>
          </h:link>
        </h:panelGrid>
      </f:facet>
      <c:forEach items="#{item.items}" var="child">
        <rich:menuGroup rendered="#{child.visible and not empty child.items}" label="#{messages[child.page.label]}">
          <f:facet name="icon">
            <h:graphicImage library="img" value="#{child.page.icon}" width="32" height="32"/>
          </f:facet>
          <c:forEach items="#{child.items}" var="subChild">
            <rich:menuGroup rendered="#{subChild.visible and not empty subChild.items}" label="#{messages[subChild.page.label]}">
              <f:facet name="icon">
                <h:graphicImage library="img" value="#{subChild.page.icon}" width="32" height="32"/>
              </f:facet>
              <c:forEach items="#{subChild.items}" var="subsubChild">
                <rich:menuItem submitMode="none" styleClass="menuEntry" rendered="#{subsubChild.visible}">
                  <f:facet name="icon">
                    <h:graphicImage library="img" value="#{subsubChild.page.icon}" width="32" height="32"/>
                  </f:facet>
                  <h:link styleClass="menuLink" view="#{subsubChild.page.link}" value="#{messages[subsubChild.page.label]}"/>
                </rich:menuItem>
              </c:forEach>
            </rich:menuGroup>
            <rich:menuItem rendered="#{subChild.visible and empty subChild.items}" submitMode="none" styleClass="menuEntry">
              <f:facet name="icon">
                <h:graphicImage library="img" value="#{subChild.page.icon}" width="32" height="32"/>
              </f:facet>
              <h:link styleClass="menuLink" view="#{subChild.page.link}" value="#{messages[subChild.page.label]}"/>
            </rich:menuItem>
          </c:forEach>
        </rich:menuGroup>
        <rich:menuItem rendered="#{child.visible and empty child.items}" submitMode="none" styleClass="menuEntry">
          <f:facet name="icon">
            <h:graphicImage library="img" value="#{child.page.icon}" width="32" height="32"/>
          </f:facet>
          <h:link styleClass="menuLink" view="#{child.page.link}" value="#{messages[child.page.label]}"/>
        </rich:menuItem>
      </c:forEach>
    </rich:dropDownMenu>
  </c:forEach>
  <rich:jQuery selector=".menuEntry" query="click(function() {location.href = jQuery(this).find('a').attr('href') })"/>
</ui:composition>
